Index: CKEditor/trunk/_source/plugins/editingblock/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/editingblock/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/editingblock/plugin.js	(revision 5189)
@@ -96,23 +96,4 @@
 					event.removeListener();
 
-					// Grab editor focus if the editor container is focused. (#3104)
-					var focusGrabber = editor.container;
-
-					// Safari 3 can't handle tabindex in all elements, so we do
-					// a trick to make it move the focus to the editor on TAB.
-					if ( CKEDITOR.env.webkit && CKEDITOR.env.version < 528 )
-					{
-						var tabIndex = editor.config.tabIndex || editor.element.getAttribute( 'tabindex' ) || 0;
-						focusGrabber = focusGrabber.append( CKEDITOR.dom.element.createFromHtml(
-							'<input' +
-								' tabindex="' + tabIndex + '"' +
-								' style="position:absolute; left:-10000">' ) );
-					}
-
-					focusGrabber.on( 'focus', function()
-						{
-							editor.focus();
-						});
-
 					if ( editor.config.startupFocus )
 						editor.focus();
Index: CKEditor/trunk/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -50,5 +50,9 @@
 				{
 					if ( event.data.space == 'bottom' )
-						event.data.html += '<div id="' + spaceId + '" class="cke_path">' + emptyHtml + '</div>';
+					{
+						event.data.html +=
+							'<span id="' + spaceId + '_label" class="cke_voice_label">' + editor.lang.elementsPath.eleLabel + '</span>' +
+							'<div id="' + spaceId + '" class="cke_path" role="group" aria-labelledby="' + spaceId + '_label">' + emptyHtml + '</div>';
+					}
 				});
 
@@ -87,4 +91,5 @@
 							extra += ' onblur="this.style.cssText = this.style.cssText;"';
 
+						var label = editor.lang.elementsPath.eleTitle.replace( /%1/, name );
 						html.unshift(
 							'<a' +
@@ -92,5 +97,5 @@
 								' href="javascript:void(\'', name, '\')"' +
 								' tabindex="-1"' +
-								' title="', editor.lang.elementsPath.eleTitle.replace( /%1/, name ), '"' +
+								' title="', label, '"' +
 								( ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 ) ?
 								' onfocus="event.preventBubble();"' : '' ) +
@@ -98,6 +103,8 @@
 								' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', this.name, '\',', index, ', event);"' +
 								extra ,
-								' onclick="return CKEDITOR._.elementsPath.click(\'', this.name, '\',', index, ');">',
+								' onclick="return CKEDITOR._.elementsPath.click(\'', this.name, '\',', index, ');"',
+								' role="button" aria-labelledby="' + idBase + index + '_label">',
 									name,
+									'<span id="', idBase, index, '_label" class="cke_label">' + label + '</span>',
 							'</a>' );
 
Index: CKEditor/trunk/_source/plugins/find/dialogs/find.js
===================================================================
--- CKEditor/trunk/_source/plugins/find/dialogs/find.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/find/dialogs/find.js	(revision 5189)
@@ -817,8 +817,5 @@
 				finder.searchRange = getSearchRange();
 
-				if ( startupPage == 'replace' )
-					this.getContentElement( 'replace', 'txtFindReplace' ).focus();
-				else
-					this.getContentElement( 'find', 'txtFindFind' ).focus();
+				this.selectPage( startupPage );
 			},
 			onHide : function()
@@ -834,4 +831,11 @@
 				// Clear current session before dialog close
 				delete finder.matchRange;
+			},
+			onFocus : function()
+			{
+				if ( startupPage == 'replace' )
+					return this.getContentElement( 'replace', 'txtFindReplace' );
+				else
+					return this.getContentElement( 'find', 'txtFindFind' );
 			}
 		};
Index: CKEditor/trunk/_source/plugins/flash/dialogs/flash.js
===================================================================
--- CKEditor/trunk/_source/plugins/flash/dialogs/flash.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/flash/dialogs/flash.js	(revision 5189)
@@ -175,5 +175,5 @@
 
 		var previewPreloader,
-			previewAreaHtml = '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.image.preview ) +'<br>' +
+			previewAreaHtml = '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.common.preview ) +'<br>' +
 			'<div id="FlashPreviewLoader" style="display:none"><div class="loading">&nbsp;</div></div>' +
 			'<div id="FlashPreviewBox"></div></div>';
@@ -301,8 +301,4 @@
 							[
 								{
-									type : 'html',
-									html : '<span>' + CKEDITOR.tools.htmlEncode( editor.lang.image.url ) + '</span>'
-								},
-								{
 									type : 'hbox',
 									widths : [ '280px', '110px' ],
@@ -313,5 +309,6 @@
 											id : 'src',
 											type : 'text',
-											label : '',
+											label : editor.lang.common.url,
+											required : true,
 											validate : CKEDITOR.dialog.validate.notEmpty( editor.lang.flash.validateSrc ),
 											setup : loadValue,
@@ -348,5 +345,7 @@
 											filebrowser : 'info:src',
 											hidden : true,
-											align : 'center',
+											// v-align with the 'src' field.
+											// TODO: We need something better than a fixed size here.
+											style : 'display:inline-block;margin-top:10px;',
 											label : editor.lang.common.browseServer
 										}
@@ -583,43 +582,46 @@
 						},
 						{
-							type : 'vbox',
-							padding : 0,
-							children :
-							[
-								{
-									type : 'html',
-									html : CKEDITOR.tools.htmlEncode( editor.lang.flash.flashvars )
-								},
-								{
-									type : 'checkbox',
-									id : 'menu',
-									label : editor.lang.flash.chkMenu,
-									'default' : true,
-									setup : loadValue,
-									commit : commitValue
-								},
-								{
-									type : 'checkbox',
-									id : 'play',
-									label : editor.lang.flash.chkPlay,
-									'default' : true,
-									setup : loadValue,
-									commit : commitValue
-								},
-								{
-									type : 'checkbox',
-									id : 'loop',
-									label : editor.lang.flash.chkLoop,
-									'default' : true,
-									setup : loadValue,
-									commit : commitValue
-								},
-								{
-									type : 'checkbox',
-									id : 'allowFullScreen',
-									label : editor.lang.flash.chkFull,
-									'default' : true,
-									setup : loadValue,
-									commit : commitValue
+							type : 'fieldset',
+							label : CKEDITOR.tools.htmlEncode( editor.lang.flash.flashvars ),
+							children :
+							[
+								{
+									type : 'vbox',
+									padding : 0,
+									children :
+									[
+										{
+											type : 'checkbox',
+											id : 'menu',
+											label : editor.lang.flash.chkMenu,
+											'default' : true,
+											setup : loadValue,
+											commit : commitValue
+										},
+										{
+											type : 'checkbox',
+											id : 'play',
+											label : editor.lang.flash.chkPlay,
+											'default' : true,
+											setup : loadValue,
+											commit : commitValue
+										},
+										{
+											type : 'checkbox',
+											id : 'loop',
+											label : editor.lang.flash.chkLoop,
+											'default' : true,
+											setup : loadValue,
+											commit : commitValue
+										},
+										{
+											type : 'checkbox',
+											id : 'allowFullScreen',
+											label : editor.lang.flash.chkFull,
+											'default' : true,
+											setup : loadValue,
+											commit : commitValue
+										}
+									]
 								}
 							]
Index: CKEditor/trunk/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 5189)
@@ -159,8 +159,8 @@
 							// inside the window itself, so we must ensure the
 							// target is out of it.
-							var target = ev.data.getTarget(),
-								targetWindow = target.getWindow && target.getWindow();
-
-							if ( targetWindow && targetWindow.equals( focused ) )
+							var target;
+							if ( CKEDITOR.env.ie && !this.allowBlur()
+								 || ( target = ev.data.getTarget() )
+								      && target.getName && target.getName() != 'iframe' )
 								return;
 
@@ -183,7 +183,8 @@
 				}
 
-				panel.onEscape = CKEDITOR.tools.bind( function()
+				panel.onEscape = CKEDITOR.tools.bind( function( keystroke )
 					{
-						this.onEscape && this.onEscape();
+						if ( this.onEscape && this.onEscape( keystroke ) === false )
+							return false;
 					},
 					this );
@@ -272,22 +273,9 @@
 						// Set the panel frame focus, so the blur event gets fired.
 						CKEDITOR.tools.setTimeout( function()
-							{
-								if ( definition.voiceLabel )
-								{
-									if ( CKEDITOR.env.gecko )
-									{
-										var container = iframe.getParent();
-										container.setAttribute( 'role', 'region' );
-										container.setAttribute( 'title', definition.voiceLabel );
-										iframe.setAttribute( 'role', 'region' );
-										iframe.setAttribute( 'title', ' ' );
-									}
-								}
-
-								iframe.$.contentWindow.focus();
-								// We need this get fired manually because of unfired focus() function.
-								this.allowBlur( true );
-
-							}, 0, this);
+						{
+							iframe.$.contentWindow.focus();
+							// We need this get fired manually because of unfired focus() function.
+							this.allowBlur( true );
+						}, 0, this);
 					}, 0, this);
 				this.visible = 1;
Index: CKEditor/trunk/_source/plugins/font/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/font/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/font/plugin.js	(revision 5189)
@@ -39,12 +39,10 @@
 				label : lang.label,
 				title : lang.panelTitle,
-				voiceLabel : lang.voiceLabel,
 				className : 'cke_' + ( styleType == 'size' ? 'fontSize' : 'font' ),
-				multiSelect : false,
-
 				panel :
 				{
 					css : editor.skin.editor.css.concat( config.contentsCss ),
-					voiceLabel : lang.panelVoiceLabel
+					multiSelect : false,
+					attributes : { 'aria-label' : lang.panelTitle }
 				},
 
Index: CKEditor/trunk/_source/plugins/format/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/format/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/format/plugin.js	(revision 5189)
@@ -28,12 +28,10 @@
 				label : lang.label,
 				title : lang.panelTitle,
-				voiceLabel : lang.voiceLabel,
 				className : 'cke_format',
-				multiSelect : false,
-
 				panel :
 				{
 					css : editor.skin.editor.css.concat( config.contentsCss ),
-					voiceLabel : lang.panelVoiceLabel
+					multiSelect : false,
+					attributes : { 'aria-label' : lang.panelTitle }
 				},
 
Index: CKEditor/trunk/_source/plugins/forms/dialogs/form.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/form.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/form.js	(revision 5189)
@@ -144,5 +144,5 @@
 								id : 'target',
 								type : 'select',
-								label : editor.lang.form.target,
+								label : editor.lang.common.target,
 								style : 'width:100%',
 								accessKey : 'M',
@@ -150,9 +150,9 @@
 								items :
 								[
-									[ editor.lang.form.targetNotSet, '' ],
-									[ editor.lang.form.targetNew, '_blank' ],
-									[ editor.lang.form.targetTop, '_top' ],
-									[ editor.lang.form.targetSelf, '_self' ],
-									[ editor.lang.form.targetParent, '_parent' ]
+									[ editor.lang.common.notSet, '' ],
+									[ editor.lang.common.targetNew, '_blank' ],
+									[ editor.lang.common.targetTop, '_top' ],
+									[ editor.lang.common.targetSelf, '_self' ],
+									[ editor.lang.common.targetParent, '_parent' ]
 								]
 							},
Index: CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 5189)
@@ -186,4 +186,9 @@
 					if ( !element.attributes.type )
 						element.attributes.type = 'text/css';
+				},
+
+				title : function( element )
+				{
+					element.children[ 0 ].value = element.attributes[ '_cke_title' ];
 				}
 			},
Index: CKEditor/trunk/_source/plugins/image/dialogs/image.js
===================================================================
--- CKEditor/trunk/_source/plugins/image/dialogs/image.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/image/dialogs/image.js	(revision 5189)
@@ -147,4 +147,10 @@
 		else
 			ratioButton.addClass( 'cke_btn_unlocked' );
+
+		var lang = dialog._.editor.lang.image,
+			label =  lang[  dialog.lockRatio ? 'unlockRatio' : 'lockRatio' ];
+
+		ratioButton.setAttribute( 'title', label );
+		ratioButton.getFirst().setText( label );
 
 		return dialog.lockRatio;
@@ -461,8 +467,4 @@
 							[
 								{
-									type : 'html',
-									html : '<span>' + CKEDITOR.tools.htmlEncode( editor.lang.image.url ) + '</span>'
-								},
-								{
 									type : 'hbox',
 									widths : [ '280px', '110px' ],
@@ -473,5 +475,6 @@
 											id : 'txtUrl',
 											type : 'text',
-											label : '',
+											label : editor.lang.common.url,
+											required: true,
 											onChange : function()
 											{
@@ -543,4 +546,7 @@
 											type : 'button',
 											id : 'browse',
+											// v-align with the 'txtUrl' field.
+											// TODO: We need something better than a fixed size here.
+											style : 'display:inline-block;margin-top:10px;',
 											align : 'center',
 											label : editor.lang.common.browseServer,
@@ -615,9 +621,9 @@
 																commitInternally.call( this, 'advanced:txtdlgGenStyle' );
 															},
-															validate: function()
+															validate : function()
 															{
 																var aMatch  =  this.getValue().match( regexGetSizeOrEmpty );
 																if ( !aMatch )
-																	alert( editor.lang.common.validateNumberFailed );
+																	alert( editor.lang.image.validateWidth );
 																return !!aMatch;
 															},
@@ -665,9 +671,9 @@
 																commitInternally.call( this, 'advanced:txtdlgGenStyle' );
 															},
-															validate: function()
+															validate : function()
 															{
 																var aMatch = this.getValue().match( regexGetSizeOrEmpty );
 																if ( !aMatch )
-																	alert( editor.lang.common.validateNumberFailed );
+																	alert( editor.lang.image.validateHeight );
 																return !!aMatch;
 															},
@@ -762,8 +768,8 @@
 													},
 													html : '<div>'+
-														'<a href="javascript:void(0)" tabindex="-1" title="' + editor.lang.image.lockRatio +
-														'" class="cke_btn_locked" id="btnLockSizes"></a>' +
+														'<a href="javascript:void(0)" tabindex="-1" title="' + editor.lang.image.unlockRatio +
+														'" class="cke_btn_locked" id="btnLockSizes" role="button"><span class="cke_label">' + editor.lang.image.unlockRatio + '</span></a>' +
 														'<a href="javascript:void(0)" tabindex="-1" title="' + editor.lang.image.resetSize +
-														'" class="cke_btn_reset" id="btnResetSize"></a>'+
+														'" class="cke_btn_reset" id="btnResetSize" role="button"><span class="cke_label">' + editor.lang.image.resetSize + '</span></a>'+
 														'</div>'
 												}
@@ -790,9 +796,5 @@
 														commitInternally.call( this, 'advanced:txtdlgGenStyle' );
 													},
-													validate: function()
-													{
-														var func = CKEDITOR.dialog.validate.integer( editor.lang.common.validateNumberFailed );
-														return func.apply( this );
-													},
+													validate : CKEDITOR.dialog.validate.integer( editor.lang.image.validateBorder ),
 													setup : function( type, element )
 													{
@@ -851,9 +853,5 @@
 														commitInternally.call( this, 'advanced:txtdlgGenStyle' );
 													},
-													validate: function()
-													{
-														var func = CKEDITOR.dialog.validate.integer( editor.lang.common.validateNumberFailed );
-														return func.apply( this );
-													},
+													validate : CKEDITOR.dialog.validate.integer( editor.lang.image.validateHSpace ),
 													setup : function( type, element )
 													{
@@ -919,9 +917,5 @@
 														commitInternally.call( this, 'advanced:txtdlgGenStyle' );
 													},
-													validate: function()
-													{
-														var func = CKEDITOR.dialog.validate.integer( editor.lang.common.validateNumberFailed );
-														return func.apply( this );
-													},
+													validate : CKEDITOR.dialog.validate.integer( editor.lang.image.validateVSpace ),
 													setup : function( type, element )
 													{
@@ -1056,5 +1050,5 @@
 											type : 'html',
 											style : 'width:95%;',
-											html : '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.image.preview ) +'<br>'+
+											html : '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.common.preview ) +'<br>'+
 											'<div id="ImagePreviewLoader" style="display:none"><div class="loading">&nbsp;</div></div>'+
 											'<div id="ImagePreviewBox">'+
@@ -1080,5 +1074,5 @@
 							id : 'txtUrl',
 							type : 'text',
-							label : editor.lang.image.url,
+							label : editor.lang.common.url,
 							style : 'width: 100%',
 							'default' : '',
@@ -1125,13 +1119,13 @@
 							id : 'cmbTarget',
 							type : 'select',
-							label : editor.lang.link.target,
+							label : editor.lang.common.target,
 							'default' : '',
 							items :
 							[
-								[ editor.lang.link.targetNotSet , ''],
-								[ editor.lang.link.targetNew , '_blank'],
-								[ editor.lang.link.targetTop , '_top'],
-								[ editor.lang.link.targetSelf , '_self'],
-								[ editor.lang.link.targetParent , '_parent']
+								[ editor.lang.common.notSet , ''],
+								[ editor.lang.common.targetNew , '_blank'],
+								[ editor.lang.common.targetTop , '_top'],
+								[ editor.lang.common.targetSelf , '_self'],
+								[ editor.lang.common.targetParent , '_parent']
 							],
 							setup : function( type, element )
Index: CKEditor/trunk/_source/plugins/keystrokes/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/keystrokes/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/keystrokes/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -215,5 +215,6 @@
 	[ CKEDITOR.CTRL + 85 /*U*/, 'underline' ],
 
-	[ CKEDITOR.ALT + 109 /*-*/, 'toolbarCollapse' ]
+	[ CKEDITOR.ALT + 109 /*-*/, 'toolbarCollapse' ],
+	[ CKEDITOR.ALT + 48 /*0*/, 'a11yHelp' ]
 ];
 
Index: CKEditor/trunk/_source/plugins/link/dialogs/anchor.js
===================================================================
--- CKEditor/trunk/_source/plugins/link/dialogs/anchor.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/link/dialogs/anchor.js	(revision 5189)
@@ -82,4 +82,5 @@
 						id : 'txtName',
 						label : editor.lang.anchor.name,
+						required: true,
 						validate : function()
 						{
